/***************************************************************************
                          simfold.h  -  description
                             -------------------
    begin                : Thu Apr 11 2002
    copyright            : (C) 2002 by Mirela Andronescu
    email                : andrones@cs.ubc.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef SIMFOLD_H
#define SIMFOLD_H

#include "constants.h"
#include "init.h"

double simfold (char *sequence, char *structure);
// PRE:  the init_data function has been called;
//       the space for structure has been allocated
// POST: fold sequence, return the MFE structure in structure, and return the MFE


double simfold_restricted (char *sequence, char *restricted, char *structure);
// PRE:  the init_data function has been called;
//       the space for structure has been allocated
// POST: fold sequence, return the MFE structure in structure, and return the MFE


double free_energy_simfold (char *sequence, char *structure);
// PRE:  sequence and structure are given as input
// !!! structure should not be sth like "...(((..)))", but a variable!!!
// POST: returns the free energy of sequence folded into structure
//       Worst case complexity = n^2 (n = length of sequence)
// (the function is implemented in s_specific_functions.cpp)

double free_energy_simfold_restricted (char *sequence, char *structure, char *restricted);


double enthalpy_simfold (char *sequence, char *structure);
// PRE:  sequence and structure are given as input
// POST: returns the enthalpy of sequence folded into structure
//       Worst case complexity = n^2 (n = length of sequence)

int simfold_restricted_all_mfe_structures (char *sequence, char *restricted, char structures[][MAXSLEN], double energies[]);
int simfold_unordered_suboptimals (char *sequence, int number, char structures[][MAXSLEN], double energies[]);
int simfold_restricted_unordered_suboptimals (char *sequence, char *restricted, int number, char structures[][MAXSLEN], double energies[]);
int simfold_restricted_all_suboptimals (char *sequence, char *restricted, char structures[][MAXSLEN], double energies[]);
double simfold_restricted_partition_function (char *sequence, char *restricted, double &min_energy, double &max_energy, int &actual_num_str);
double compute_probability (double energy, double Z);

#endif
